#include <stdio.h>
#define NOT_FOUND -1

#define SYSTEM_VERSIONSSTRING "ArchoDB Middle-Ware - query.cgi Script 0.1"
#define SYSTEM_DATABASE_IMAGE_PATH "images/"
#define SYSTEM_IMAGE_VOID "spacer_black.gif"

#define FELD_INVENTARNUMMER "Inventarnummer"
#define FELD_BEZEICHNUNG "Bezeichnung"
#define FELD_DIMENSION "Dimension"
#define FELD_VERSICHERUNGSWERT "Versicherungswert"
#define FELD_LAGERINFORMATIONEN "Lagerinformationen"
#define FELD_ENTDECKER "Entdecker"
#define FELD_FUNDORT "Fundort"
#define FELD_ALTER "Alter"
#define FELD_IMAGE "image"

#define FELD_SYSTEM_VERSION "version"

#define TEMPLATE_FILE_ARTEFACT "abfrage_template1.html"

int display_artefact_by_inv_nr(long inv_nr);
char database_get_field_by_key(char *feldname, long key, char *result);


int main(int argc, char *argv[])
{
  int c;
  int i;
  char buf[256];
  char *q;
  char *p;
  
  FILE *f;
  
  long inv_nr;
  
  // Teste auf Parameter
  
  q=getenv("QUERY_STRING");
 
  if(*q)
  {
  	// Aufruf mit Parametern -> Teste
  	if(p=strstr(q,FELD_IMAGE))
  	{
  	  // Bild ist zurckzuliefern
  	  int bildnr;
  	  while(*p!='=' && *p) p++;
    	  bildnr=atoi(p+1);
    	  p=strstr(q,FELD_INVENTARNUMMER);
  	  while(*p!='=' && *p) p++;
    	  inv_nr=atoi(p+1);
    	  
    	  sprintf(buf,"%sartefakt-%d-%d.jpg",SYSTEM_DATABASE_IMAGE_PATH,inv_nr,bildnr);
    	  f=fopen(buf,"rb");
	  if(f)
	  { 
	    printf("Content-type: image/jpeg\n\n");	   
	    while((c=fgetc(f))!=EOF) putc((char)c,stdout);    	  	
    	    fclose(f);
    	  }
    	  else
    	  {
    	    sprintf(buf,"%s%s",SYSTEM_DATABASE_IMAGE_PATH,SYSTEM_IMAGE_VOID);
    	    f=fopen(buf,"rb");
	    printf("Content-type: image/gif\n\n");	   
	    while((c=fgetc(f))!=EOF) putc((char)c,stdout);    	  	
	    fclose(f);    	    
    	  }
    	}
  	else
  	  // Andere Arten derzeit nicht implementiert
  	  printf("Content-type: text/html\n\nERROR - Invalid parameters");
  	  	  	
  }
  else
  { 
    // Datenbankabfrage starten
    
    printf("Content-type: text/html\n\n");

    inv_nr=NOT_FOUND;
    while(fgets(buf,255,stdin))
    {
      if(q=strstr(buf,FELD_INVENTARNUMMER))
      {
    	  while(*q!='=' && *q) q++;
    	  if(*q) inv_nr=atol(q+1);
      }
  	
    }
    if(inv_nr!=NOT_FOUND)
      display_artefact_by_inv_nr(inv_nr);
    else
    printf("ERROR - Invalid usage of script");
  }
  // Ende des Scripts
}

  
int display_artefact_by_inv_nr(long inv_nr)
{  
  FILE *f;
  char *p;
  char buf[513];
  char buf2[513];
  char term[513];
  
  // Parsen des Template Files fuer die Antwort und Ausgabe
  f=fopen(TEMPLATE_FILE_ARTEFACT,"ra");
  
  while(fgets(buf,255,f)) 
  {
    strcpy(buf2,buf);
    // Inventarnummer in Template einfgen
    if((p=strstr(buf, "$$" FELD_INVENTARNUMMER)))
    { 
      sprintf(term,"%d",inv_nr);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_INVENTARNUMMER));
    }

    strcpy(buf2,buf);
    // Bezeichnung in Template einfgen
    if((p=strstr(buf, "$$" FELD_BEZEICHNUNG)))
    { 
      database_get_field_by_key(FELD_BEZEICHNUNG, inv_nr, term);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_BEZEICHNUNG));
    }
    strcpy(buf2,buf);
    // Dimension in Template einfgen
    if((p=strstr(buf, "$$" FELD_DIMENSION)))
    { 
      database_get_field_by_key(FELD_DIMENSION, inv_nr, term);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_DIMENSION));
    }
    strcpy(buf2,buf);
    // Versicherungswert in Template einfgen
    if((p=strstr(buf, "$$" FELD_VERSICHERUNGSWERT)))
    { 
      database_get_field_by_key(FELD_VERSICHERUNGSWERT, inv_nr, term);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_VERSICHERUNGSWERT));
    }
    strcpy(buf2,buf);
    // Lagerinformationen in Template einfgen
    if((p=strstr(buf, "$$" FELD_LAGERINFORMATIONEN)))
    { 
      database_get_field_by_key(FELD_LAGERINFORMATIONEN, inv_nr, term);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_LAGERINFORMATIONEN));
    }
    strcpy(buf2,buf);
    // Entdecker in Template einfgen
    if((p=strstr(buf, "$$" FELD_ENTDECKER)))
    { 
      database_get_field_by_key(FELD_ENTDECKER, inv_nr, term);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_ENTDECKER));
    }
    strcpy(buf2,buf);
    // Fundort in Template einfgen
    if((p=strstr(buf, "$$" FELD_FUNDORT)))
    { 
      database_get_field_by_key(FELD_FUNDORT, inv_nr, term);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_FUNDORT));
    }
    strcpy(buf2,buf);
    // Alter in Template einfgen
    if((p=strstr(buf, "$$" FELD_ALTER)))
    { 
      database_get_field_by_key(FELD_ALTER, inv_nr, term);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_ALTER));
    }
    strcpy(buf2,buf);
    // Image in Template einfgen
    if((p=strstr(buf, "$$" FELD_IMAGE)))
    { 
      sprintf(term,"query.cgi?" FELD_INVENTARNUMMER "=%ld&" FELD_IMAGE "=1",inv_nr);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_IMAGE));
    }
  
    // SYSTEM Daten einfgen
    
    strcpy(buf2,buf);
    // Systemversion
    if((p=strstr(buf, "$$" FELD_SYSTEM_VERSION)))
    { 
      sprintf(term,"%s",SYSTEM_VERSIONSSTRING);
      strcpy(p,term);
      strcpy(p+strlen(term),buf2+(p-buf)+strlen( "$$" FELD_SYSTEM_VERSION));
    }
 
    fputs(buf,stdout);
  }
  fclose(f);
  return -1;
}



// 1ster Versuch! eine einfachen, abstrakten Datenbankschnittstelle
// muss natuerlich noch sehr stark veraengert werden und soll mal was in der form von
// select feldname from DATENBANKNAMEN where key=unserkey 
// oder so an eine SQL Datenbank senden....

// Da wir z.Z. keine reale Datenbank haben (aus Kostengruenden) verwenden wir hier eine Dummy Funktion
char database_get_field_by_key(char *feldname, long key, char *result)
{
	if(strcmp(feldname, FELD_BEZEICHNUNG)==0) strcpy(result,"n.v.");
	if(strcmp(feldname, FELD_BEZEICHNUNG)==0 && key==1) strcpy(result,"Groer schwarzer Sarg");
	if(strcmp(feldname, FELD_BEZEICHNUNG)==0 && key==2) strcpy(result,"Pyramide");
	if(strcmp(feldname, FELD_BEZEICHNUNG)==0 && key==3) strcpy(result,"Fluch mittlerer Gre");
	
	if(strcmp(feldname, FELD_DIMENSION)==0) strcpy(result,"n.v.");
	if(strcmp(feldname, FELD_DIMENSION)==0 && key==1) strcpy(result,"1x2x1 m");
	if(strcmp(feldname, FELD_DIMENSION)==0 && key==2) strcpy(result,"grooossss");
	

	if(strcmp(feldname, FELD_VERSICHERUNGSWERT)==0) strcpy(result,"n.v.");
	if(strcmp(feldname, FELD_VERSICHERUNGSWERT)==0 && key==2) strcpy(result,"543817 Kamele");
	if(strcmp(feldname, FELD_VERSICHERUNGSWERT)==0 && key==3) strcpy(result,"Nicht versicherbar");
	
	if(strcmp(feldname, FELD_LAGERINFORMATIONEN)==0) strcpy(result,"n.v.");
	if(strcmp(feldname, FELD_LAGERINFORMATIONEN)==0 && key==1) strcpy(result,"Khl und trocken lagern - mindestens haltbar bis hier Deckel");
	
	if(strcmp(feldname, FELD_ENTDECKER)==0) strcpy(result,"n.v.");
	if(strcmp(feldname, FELD_ENTDECKER)==0 && key==1) strcpy(result,"Huber Sepp");
	if(strcmp(feldname, FELD_ENTDECKER)==0 && key==3) strcpy(result,"hat den Fluch nicht berlebt");
	
	if(strcmp(feldname, FELD_FUNDORT)==0) strcpy(result,"n.v.");
	if(strcmp(feldname, FELD_FUNDORT)==0 && key==1) strcpy(result,"gypten");
	if(strcmp(feldname, FELD_FUNDORT)==0 && key==2) strcpy(result,"gypten");
	if(strcmp(feldname, FELD_FUNDORT)==0 && key==3) strcpy(result,"Cosy");
	
	if(strcmp(feldname, FELD_ALTER)==0) strcpy(result,"n.v.");
	if(strcmp(feldname, FELD_ALTER)==0 && key==1) strcpy(result,"4000 Jahre");
	if(strcmp(feldname, FELD_ALTER)==0 && key==3) strcpy(result,"wenige Stunden");
	return -1;
}